=== debian/changelog ===
android-platform-external-boringssl (14.0.0+r11-4build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:42:36 +0200

android-platform-external-boringssl (14.0.0+r11-4) unstable; urgency=medium

  * debian/control: Remove android-boringssl package for hurd-*.

 -- Roger Shimizu <rosh@debian.org>  Sun, 12 Nov 2023 01:07:44 -0800

android-platform-external-boringssl (14.0.0+r11-3) unstable; urgency=medium

  * debian/watch: Keep upstream version same as upstream's one
  * Add alpha arc hurd-amd64 loong64 - all little endian systems.
  * Revert "d/include: Add chrono header from libstdc++-13-dev to fix ftbfs
    for gcc-13".

 -- Roger Shimizu <rosh@debian.org>  Sat, 11 Nov 2023 16:39:51 -0800

android-platform-external-boringssl (14.0.0+r11-2) unstable; urgency=medium

  * debian/rules: Skip building compiler_test for hurd-i386.

 -- Roger Shimizu <rosh@debian.org>  Thu, 09 Nov 2023 20:38:45 -0800

android-platform-external-boringssl (14.0.0+r11-1) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Tue, 07 Nov 2023 00:20:55 -0800

android-platform-external-boringssl (14.0.0+r11-1~exp1) experimental; urgency=medium

  * New upstream release 14.0.0+r11
  * debian/sources.mk: Update by script.

 -- Roger Shimizu <rosh@debian.org>  Sun, 05 Nov 2023 21:06:33 -0800

android-platform-external-boringssl (14~beta1-1~exp2) experimental; urgency=medium

  * debian/patches: Add patch to revert remove support for ppc64le.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Jul 2023 02:48:52 -0700

android-platform-external-boringssl (14~beta1-1~exp1) experimental; urgency=medium

  * New upstream release 14~beta1
  * debian/patches: Refresh patches.
  * debian/compiler_test.mk: Update for new upstream version.
  * debian/*.mk: Move c&cpp std version to d/rules.
  * debian/*_test.mk: Remove no need android lib rpath.

 -- Roger Shimizu <rosh@debian.org>  Sun, 30 Jul 2023 00:02:10 -0700

android-platform-external-boringssl (13.0.0+r24-3) unstable; urgency=medium

  * Add debian/README.packaging
  * debian/include:
    - Add chrono header from libstdc++-13-dev to fix ftbfs for gcc-13
      (Closes: #1037575).

 -- Roger Shimizu <rosh@debian.org>  Sat, 22 Jul 2023 20:58:12 -0700
