=== debian/watch ===
# uscan --download-version 12.1.0+r5

version=4
opts="mode=git, \
      pgpmode=gittag, \
      oversionmangle=s%_r(\d+|\d+\.\d+|\w)%+r$1%, \
      compression=xz" \
https://android.googlesource.com/platform/external/boringssl \
      refs/tags/android-([0-9\.]+_r\d+|\d+\.\d+|\w)
