=== debian/changelog ===
android-platform-external-boringssl (14.0.0+r45-3) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Sun, 31 Aug 2025 00:32:07 -0700

android-platform-external-boringssl (14.0.0+r45-3~exp1) experimental; urgency=medium

  * d/rules: Update the lib dependencies to fix FTBFS with make
    --shuffle=reverse (Closes: #1105274).

 -- Roger Shimizu <rosh@debian.org>  Sat, 12 Jul 2025 22:27:55 +0200

android-platform-external-boringssl (14.0.0+r45-2) unstable; urgency=medium

  * Upload to unstable.

 -- Roger Shimizu <rosh@debian.org>  Thu, 20 Mar 2025 22:53:44 -0700

android-platform-external-boringssl (14.0.0+r45-2~exp1) experimental; urgency=medium

  * debian/patches:
    - Add alpha port support.
    - Add loong64 support (Closes: #1074565).

 -- Roger Shimizu <rosh@debian.org>  Sun, 16 Mar 2025 23:40:40 -0700

android-platform-external-boringssl (14.0.0+r45-1) unstable; urgency=medium

  * New upstream release 14.0.0+r45

 -- Roger Shimizu <rosh@debian.org>  Mon, 16 Sep 2024 01:03:12 -0700
